;;HACK
(define-syntax-rule (define-module- name args ...)
  (cond-expand
   (guile-3
    (define-module name
      #:declarative? #f
      args ...))
   (guile
    (define-module name args ...))))


(define-module- (ice-9 set basic)
  #:use-module (logic guile-log iso-prolog)
  #:use-module (logic guile-log prolog goal-functors)
  #:use-module (logic guile-log)
  #:use-module ((logic guile-log umatch) #:select (gp-lookup gp->scm))
  #:use-module (logic guile-log vlist)
  #:use-module (srfi srfi-9)
  #:use-module (srfi srfi-9 gnu)
;  #:use-module (oop goops)
  #:use-module (logic guile-log prolog goal)
  #:use-module ((logic guile-log prolog goal-transformers) 
		#:select (mk-prolog-biop-tr 
			  mk-scheme-biop 
			  mk-prolog-biop 
			  s a))
  #:export 
  (<simple-set> make-simple-set
   set_adition set_difference set_union set_intersection
	       subset subseteq set_equiv
	       set_to_list list_to_set 
	       oset_union oset_intersection oset_addition))

;;TODO: Wrap this in an attribute making unification work out of the box.

#|
;; Functional ordered set? how do we approach that
(define-class <Set> () list vhash n hash)

;  (list  #:getter set-list)
;  (vhash #:getter set-vhash)
;  (n     #:getter set-n))

(define (make-set x y z) 
  (let ((ret (make-instance <Set>)))
    (slot-set! ret 'list  x)
    (slot-set! ret 'vhash y)
    (slot-set! ret 'n     z)))

(define (set-list  x) (slot-ref x 'list))
(define (set-vhash x) (slot-ref x 'vhash))
(define (set-n     x) (slot-ref x 'n))

(define (set? x) (is-a? x <Set>))
|#


(define-record-type <simple-set>
  (make-simple-set list vhash n hash)
  simple-set?
  (list  set-list)
  (vhash set-vhash)
  (n     set-n)
  (hash  set-hash))

(set-record-type-printer! <simple-set>
  (lambda (vl port) 
    (format port "#<set len=~a>" (set-n vl))))

(define ∅ (make-set '() vlist-null 0 0))  


(define make-one
  (case-lambda 
   ((s x)
    (let ((x (gp->scm x s)))
      (make-one x)))
   ((x)
    (make-set (list x) (vhash-cons x #t vlist-null) 1 (hash x size)))))

(<define> (set_to_list x z)
  (<let*> ((x (<lookup> x))
	   (x (if (set? x) x (make-one S x))))
    (<=> z ,(set-list (do-truncate (set-list x) (set-vhash x) (set-n x))))))

(<define> (list_to_set l z)
  (is_list l)
  (<recur> lp ((l (reverse (<scm> l))) (r ∅))
    (<<match>> (#:mode -) (l)
      ((x . l)
       (lp l (set_union S x r)))
      (()
       (<=> z l)))))

(define size 1000000000)
(define (do-truncate ll vl n)
  (let lp ((v vlist-null) (i 0) (l '()) (ll ll) (h 0))
    (if (pair? ll)
	(let ((z (car ll)))
	  (if (and (vhash-ref vl z #f) (not (vhash-ref v z #f)))
	      (lp (vhash-cons z #t v)
		  (+ i 1)
		  (cons z l)
		  (cdr ll)
		  (logxor h (hash z size)))
	      (lp v i l (cdr ll) h)))
	(make-set (reverse l) v i h))))


(define (maybe-truncate ll vl n h)
  (let ((nn (vlist-length vl)))
    (if #t #;(> nn (* 2 n))
	(do-truncate ll vl n)
	(make-set    ll vl n h))))
	      
(define-syntax-rule (swap x y)
  (let ((t x)) (set! x y) (set! y t)))

(define oset_union 
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (oset_union s x (apply oset_union s y z l)))
   ((s x y)
    ((<lambda> () 
     (<let*> ((x     (<lookup> x))
	      (x     (if (set? x) x (make-one S x)))
	      (y     (<lookup> y))
	      (y     (if (set? y) y (make-one S y)))
	      (nx    (set-n x))
	      (ny    (set-n y))
	      (swap? #f))
       (if (or (< nx ny) (not (= nx (vlist-length x))))
	   (<code> (swap x y) (swap nx ny) (set! swap? #t))
	   <cc>)
       (<let*> ((vx  (set-vhash x))
		(vy  (set-vhash y))
		(lx  (set-list  x))
		(ly  (set-list  y))
		(new (let lp ((ly ly) (l '()) (v vx) (n nx) (h (set-hash x)))
		       (if (pair? ly)
			   (let ((z (car ly)))
			     (if (vhash-ref vy z #f)
				 (if (vhash-ref vx z #f)
				     (lp (cdr ly) l v n h)
				     (lp (cdr ly) 
					 (cons z l) 
					 (vhash-cons z #t v)
					 (+ n 1)
					 (logxor h (hash z size))))
				 (lp (cdr ly) l v n h)))
			   (maybe-truncate (if swap?
					       ((@ (guile) append)
						(reverse l) lx)
					       ((@ (guile) append) 
						lx (reverse l)))
					   v n h)))))
	       (<cc> new))))			    	      
   s (lambda () #f) (lambda (p cc x) x)))))

(define set_union 
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (set_union s x (apply set_union s y z l)))
   ((s x y)
    ((<lambda> () 
     (<let*> ((x     (<lookup> x))
	      (x     (if (set? x) x (make-one S x)))
	      (y     (<lookup> y))
	      (y     (if (set? y) y (make-one S y)))
	      (nx    (set-n x))
	      (ny    (set-n y))
	      (swap? #f))
       (if (< nx ny)
	   (<code> (swap x y) (swap nx ny) (set! swap? #t))
	   <cc>)
       (<let*> ((vx  (set-vhash x))
		(vy  (set-vhash y))
		(lx  (set-list  x))
		(ly  (set-list  y))
		(new (let lp ((ly ly) (l '()) (v vx) (n nx) (h (set-hash x)))
		       (if (pair? ly)
			   (let ((z (car ly)))
			     (if (vhash-ref vy z #f)
				 (if (vhash-ref vx z #f)
				     (lp (cdr ly) l v n h)
				     (lp (cdr ly) 
					 (cons z l) 
					 (vhash-cons z #t v)
					 (+ n 1)
					 (logxor h (hash z size))))
				 (lp (cdr ly) l v n h)))
			   (maybe-truncate (if swap?
					       ((@ (guile) append)
						(reverse l) lx)
					       ((@ (guile) append) 
						lx (reverse l)))
					   v n h)))))
	       (<cc> new))))			    	      
   s (lambda () #f) (lambda (p cc x) x)))))

(define (set_difference s x y)
  ((<lambda> () 
     (<let*> ((x  (<lookup> x))
	      (x  (if (set? x) x (make-one S x)))
	      (y  (<lookup> y))
	      (y  (if (set? y) y (make-one S y)))
	      (nx (set-n x))
	      (ny (set-n y))
	      (vx (set-vhash x))
	      (vy (set-vhash y))
	      (lx (set-list  x))
	      (ly (set-list  y)))
        (<cc> (let lp ((l ly) (n nx) (v vx) (h (set-hash x)))
		(if (pair? l)
		    (let ((z (car l)))
		      (if (vhash-ref vy z #f)
			  (if (vhash-ref vx z #f)
			      (lp (cdr l) (- n 1) (vhash-cons z #f v) 
				  (logxor h (hash z size)))
			      (lp (cdr l) n       v h))
			  (lp (cdr l) n v h)))
		    (maybe-truncate lx v n h))))))
   s (lambda () #f) (lambda (p cc x) x)))

(define set_intersection
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (set_intersection s x (apply set_intersection s y z l)))
   ((s x y)
    (define-syntax-rule (swap x y)
      (let ((t x)) (set! x y) (set! y t)))
    ((<lambda> () 
      (<let*> ((x  (<lookup> x))
	       (x  (if (set? x) x (make-one S x)))
	       (y  (<lookup> y))
	       (x  (if (set? y) y (make-one S y)))
	       (nx (set-n x))
	       (ny (set-n y)))
       (if (> nx ny)
	   (<code> (swap x y) (swap nx ny))
	   <cc>)
       (<let*> ((vx  (set-vhash x))
		(vy  (set-vhash y))
		(lx  (set-list  x))
		(ly  (set-list  y))
		(new (let lp ((l lx) (v vx) (n nx) (h (set-hash x)))
		       (if (pair? ly)
			   (let ((z (car l)))
			     (if (vhash-ref vx z #f)
				 (if (vhash-ref vy z #f)
				     (lp (cdr ly) v n h)
				     (lp (cdr l) 
					 (vhash-cons z #f v)
					 (- n 1)
					 (logxor h (hash z size))))
				 (lp (cdr l) v n h)))
			   (maybe-truncate lx v n h)))))
	       (<cc> new))))			    	      
     s (lambda () #f) (lambda (p cc x) x)))))

(define oset_intersection
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (oset_intersection s x (apply oset_intersection s y z l)))
   ((s x y)
    (define-syntax-rule (swap x y)
      (let ((t x)) (set! x y) (set! y t)))
    ((<lambda> () 
      (<let*> ((x  (<lookup> x))
	       (x  (if (set? x) x (make-one S x)))
	       (y  (<lookup> y))
	       (x  (if (set? y) y (make-one S y)))
	       (nx (set-n x))
	       (ny (set-n y)))
       (<let*> ((vx  (set-vhash x))
		(vy  (set-vhash y))
		(lx  (set-list  x))
		(ly  (set-list  y))
		(new (let lp ((l lx) (v vx) (n nx) (h (set-hash x)))
		       (if (pair? ly)
			   (let ((z (car l)))
			     (if (vhash-ref vx z #f)
				 (if (vhash-ref vy z #f)
				     (lp (cdr ly) v n h)
				     (lp (cdr l) 
					 (vhash-cons z #f v)
					 (- n 1)
					 (logxor h (hash z size))))
				 (lp (cdr l) v n h)))
			   (maybe-truncate lx v n h)))))
	       (<cc> new))))			    	      
     s (lambda () #f) (lambda (p cc x) x)))))


(define set_addition 
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (set_addition s x (apply set_addition s y z l)))
   ((s x y)
    (set_union s 
	       (set_difference s x y)
	       (set_difference s y x)))))

(define oset_addition 
  (case-lambda
   ((s x) x)
   ((s x y z . l)
    (oset_addition s x (apply oset_addition s y z l)))
   ((s x y)
    (oset_union s 
	       (set_difference s x y)
	       (set_difference s y x)))))
   
(define-syntax-rule (mk nm1 nm2) (define-syntax-rule (nm1 x y) (nm2 (gp-lookup x S) y)))
(mk set_union_        oset_union        )
(mk set_addition_     oset_addition     )
(mk set_difference_   set_difference    )
(mk set_intersection_ oset_intersection )

(mk-scheme-biop 'yfx "∪" tr-∪ ∪ set_union_        s s)
(mk-scheme-biop 'yfx "⊕" tr-⊕ ⊕ set_addition_     s s)
(mk-scheme-biop 'yfx "∖" tr-∖ ∖ set_difference_   s s)
(mk-scheme-biop 'yfx "∩" tr-∩ ∩ set_intersection_ s s)


(<define> (set_in x y)
   (<let*> ((x (<lookup> x))
	    (y (<lookup> y))
	    (y (if (set? y) y (make-one S y))))
     (when (vhash-ref (set-vhash y) x #f))))


(mk-prolog-biop 'xfx "∈" tr-∈ ∈ set_in s s)

(<define> (subseteq x y)
   (<let*> ((x  (<lookup> x))
	    (x  (if (set? x) x (make-one S x)))
	    (nx (set-n x))
	    (y  (<lookup> y))
	    (y  (if (set? y) y (make-one S y)))
	    (ny (set-n y)))
     (cond
      ((eq? nx 0) <cc>)
      ((< ny nx) <fail>)
      (else
       (<let> ((vx (set-vhash x))
	       (vy (set-vhash y)))
       (when (let lp ((l (set-list x)))
	       (if (pair? l)
		   (let ((z (car l)))
		     (if (vhash-ref vx x #f)
			 (if (vhash-ref vy x #f)
			     (lp (cdr l))
			     #f)
			 (lp (cdr l))))
		   #t))))))))

(<define> (subset x y)
   (<let*> ((x  (<lookup> x))
	    (x  (if (set? x) x (make-one S x)))
	    (nx (set-n x))
	    (y  (<lookup> y))
	    (y  (if (set? y) y (make-one S y)))
	    (ny (set-n y)))
     (cond
      ((eq? nx 0) <cc>)
      ((<= ny nx) <fail>)
      (else
       (<let> ((vx (set-vhash x))
	       (vy (set-vhash y)))
       (when (let lp ((l (set-list x)))
	       (if (pair? l)
		   (let ((z (car l)))
		     (if (vhash-ref vx x #f)
			 (if (vhash-ref vy x #f)
			     (lp (cdr l))
			     #f)
			 (lp (cdr l))))
		   #t))))))))

(define (equiv? x y)
 (let* ((x  (if (set? x) x (make-one x)))
	(nx (set-n x))
	(y  (if (set? y) y (make-one y)))
	(ny (set-n y)))
   (cond
    ((not (eq? ny nx))                
     #f)
    ((not (eq? (set-hash x) (set-hash y)))
     #f)
    (else
      (let ((vx (set-vhash x))
	    (vy (set-vhash y)))
	(let lp ((l (set-list x)))
	  (if (pair? l)
	      (let ((z (car l)))
		(if (vhash-ref vx x #f)
		    (if (vhash-ref vy x #f)
			(lp (cdr l))
			#f)
		    (lp (cdr l))))
	      #t)))))))

(<define> (set_equiv x y)
  (<let*> ((x  (<lookup> x))
	   (y  (<lookup> y)))
    (when (equiv? x y))))
	 
(<define> (supset   x y) (subset   y x))
(<define> (supseteq x y) (subseteq y x))

(mk-prolog-biop 'xfx "⊆" tr-⊆ ⊆ subseteq  s s)
(mk-prolog-biop 'xfx "⊂" tr-⊂ ⊂ subset    s s)
(mk-prolog-biop 'xfx "⊇" tr-⊇ ⊇ supseteq  s s)
(mk-prolog-biop 'xfx "⊃" tr-⊃ ⊃ supset    s s)
(mk-prolog-biop 'xfx "≡" tr-≡ ≡ set_equiv s s)
	  
#;(define-method (equal? (a <Set>) (b <Set>)) (pk 'equal) (equiv? a b))

#;
(compile-prolog-string "f(X,Y,Z,W) :- X is 1 ∪ 2, XX is 2 ∪ 1, X==XX, Y is 1 ∪ 3, Z is X ⊕ Y ∪ 5, W ∈ Z.")
